From bf718b4d75a3a22c9e0b9426c0502fe066bd56b3 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Jan=20Stan=C4=9Bk?= <jstanek@redhat.com>
Date: Mon, 29 Aug 2022 15:07:34 +0200
Subject: [PATCH] make: don't rebuild files on `make install`
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

The original Makefile does not allow for clean separation of build and
install steps, and re-compiles the library on `make install`.

Using [empty target files][], the re-compilation is skipped on install.
Adapted from [Debian patch][].

[empty target files]: https://www.gnu.org/software/make/manual/make.html#Empty-Targets
[Debian patch]: https://salsa.debian.org/rust-team/wasi-libc/-/blob/master/debian/patches/dont-rebuild-install.patch

Signed-off-by: Jan Staněk <jstanek@redhat.com>
Signed-off-by: rpm-build <rpm-build>
---
 Makefile | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

diff --git a/Makefile b/Makefile
index 542b43e..7b70477 100644
--- a/Makefile
+++ b/Makefile
@@ -771,6 +771,9 @@ ifeq ($(WASI_SNAPSHOT), p2)
 		> "$(SYSROOT_INC)/__wasi_snapshot.h"
 endif
 
+	# Mark this rule as done
+	touch $@
+
 startup_files: include_dirs $(LIBC_BOTTOM_HALF_CRT_OBJS)
 	#
 	# Install the startup files (crt1.o etc).
@@ -778,6 +781,9 @@ startup_files: include_dirs $(LIBC_BOTTOM_HALF_CRT_OBJS)
 	mkdir -p "$(SYSROOT_LIB)" && \
 	cp $(LIBC_BOTTOM_HALF_CRT_OBJS) "$(SYSROOT_LIB)"
 
+	# Mark this rule finished
+	touch $@
+
 # TODO: As of this writing, wasi_thread_start.s uses non-position-independent
 # code, and I'm not sure how to make it position-independent.  Once we've done
 # that, we can enable libc.so for the wasi-threads build.
@@ -796,6 +802,7 @@ endif
 endif
 
 libc_so: include_dirs $(LIBC_SO)
+	touch $@
 
 STATIC_LIBS = \
     $(SYSROOT_LIB)/libc.a \
@@ -812,6 +819,7 @@ STATIC_LIBS += \
 endif
 
 libc: include_dirs $(STATIC_LIBS)
+	touch $@
 
 dummy_libs:
 	#
@@ -821,11 +829,13 @@ dummy_libs:
 	for name in m rt pthread crypt util xnet resolv; do \
 	    $(AR) crs "$(SYSROOT_LIB)/lib$${name}.a"; \
 	done
+	touch $@
 
 finish: startup_files libc dummy_libs
 	#
 	# The build succeeded! The generated sysroot is in $(SYSROOT).
 	#
+	touch $@
 
 ifeq ($(LTO),no)
 # The check for defined and undefined symbols expects there to be a heap
@@ -1024,5 +1034,6 @@ clean:
 	$(RM) -r "$(BINDING_WORK_DIR)"
 	$(RM) -r "$(OBJDIR)"
 	$(RM) -r "$(SYSROOT)"
+	$(RM) include_dirs startup_files dummy_libs libc_so libc finish
 
-.PHONY: default startup_files libc libc_so dummy_libs finish install include_dirs clean check-symbols bindings
+.PHONY: default install clean check-symbols bindings
-- 
2.47.0

